<?php

namespace App\Controller;

use App\Entity\MembreFractal;
use App\Entity\ClasseurFractal;
use App\Form\ClasseurFractalType;
use App\Repository\ClasseurFractalRepository;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Http\Attribute\IsGranted;

#[Route('/classeur')]
#[IsGranted('IS_AUTHENTICATED_FULLY')]
class ClasseurFractalController extends AbstractController
{
    // Affichage de la liste des classeurs (avec url attaché pour les consulter)
    #[Route('/', name: 'app_classeur_fractal_index', methods: ['GET'])]
    #[IsGranted('ROLE_USER')]
    public function listAction(ManagerRegistry $doctrine)
    {
        $entityManager=$doctrine->getManager();
        if ($this->isGranted('ROLE_ADMIN')) {
            $myclasseurs=$entityManager->getRepository(ClasseurFractal::class)->findAll();
        }
        else {
            $user = $this->getUser();
            if($user) {
                    $membre = $user->getMembreFractal();
            $myclasseurs = $entityManager->getRepository(ClasseurFractal::class)->findBy(
                    [
                          'membreFractal' => $membre
                    ]);
                    return $this->render('classeur_fractal/index.html.twig', [
                        'classeurs' => $myclasseurs,
                        'membre'=>$membre
                    ]);
        }}
        return $this->render('classeur_fractal/index.html.twig', [
            'classeurs' => $myclasseurs,
        ]);
    }
    // Affichage des détails d'un classeur (nom, propriétaire, contenu)
    #[Route('/{id}', name: 'app_classeur_fractal_show', requirements: ['id' => '\d+'], methods: ['GET','POST'])]
    public function showAction(ClasseurFractal $classeurFractal): Response
    {
        $hasAccess = $this->isGranted('ROLE_ADMIN') ||
            ($this->getUser()==$classeurFractal->getMembrefractal()->getUser());
        if(! $hasAccess) {
            throw $this->createAccessDeniedException("Vous ne pouvez pas accéder à un classeur qui n'est pas le vôtre.");
        }
        return $this->render('classeur_fractal/show.html.twig', [
            'classeur' => $classeurFractal,
        ]);
    }
    #[Route('/new/{id}', name: 'app_classeur_fractal_new', methods: ['GET', 'POST'])]
    public function new(Request $request, ClasseurFractalRepository $classeurRepository, MembreFractal $member,EntityManagerInterface $entityManager): Response
    {
            $classeur = new ClasseurFractal();
            $classeur->setMembreFractal($member);
            $form = $this->createForm(ClasseurFractalType::class, $classeur);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($classeur);
            $entityManager->flush();

            return $this->redirectToRoute('app_classeur_fractal_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('classeur_fractal/new.html.twig', [
            'classeur_fractal' => $classeur,
            'form' => $form,
        ]);
    }
    #[Route('/{id}/edit', name: 'app_classeur_fractal_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, ClasseurFractal $classeurFractal, EntityManagerInterface $entityManager): Response
    {   
        $hasAccess = $this->isGranted('ROLE_ADMIN') ||
            ($this->getUser()==$classeurFractal->getMembrefractal()->getUser());
        if(! $hasAccess) {
            throw $this->createAccessDeniedException("Vous ne pouvez pas accéder à un classeur qui n'est pas le vôtre.");
        }
        $form = $this->createForm(ClasseurFractalType::class, $classeurFractal);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('app_classeur_fractal_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('classeur_fractal/edit.html.twig', [
            'classeur_fractal' => $classeurFractal,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_classeur_fractal_delete', methods: ['POST'])]
    public function delete(Request $request, ClasseurFractal $classeurFractal, EntityManagerInterface $entityManager): Response
    {
        $hasAccess = $this->isGranted('ROLE_ADMIN') ||
            ($this->getUser()==$classeurFractal->getMembrefractal()->getUser());
        if(! $hasAccess) {
            throw $this->createAccessDeniedException("Vous ne pouvez pas accéder à un classeur qui n'est pas le vôtre.");
        }
        if ($this->isCsrfTokenValid('delete'.$classeurFractal->getId(), $request->request->get('_token'))) {
            $entityManager->remove($classeurFractal);
            $entityManager->flush();
        }

        return $this->redirectToRoute('app_classeur_fractal_index', [], Response::HTTP_SEE_OTHER);
    }
}
